package LCM::Configuration::ValueChangeListeners::Install::SecureStoreListener;

use strict;
use warnings;

use SDB::Install::Globals qw($gSecureStoreTypeLSS);

sub new {
    my ($class) = @_;
    bless {}, $class;
}

sub onValueChange {
    my ($self, $value, $config) = @_;
    my $isEncryptionAlgorithmApplicable = $value eq $gSecureStoreTypeLSS;
    $config->setSkip('EncryptionAlgorithm', 1) if !$isEncryptionAlgorithmApplicable;
    return 1;
}

1;