package SDB::Common::ArrayUtils;

use strict;
use parent 'Exporter';

our @EXPORT = qw (hasDuplicates
                  haveTheSameElements);


sub hasDuplicates {
    my ($array) = @_;
    my %elementsCount = ();
    $elementsCount{$_}++ for @$array;
    return (grep {$_ > 1} values %elementsCount) ? 1 : 0;
}

sub haveTheSameElements {
    my ($a, $b) = @_;

    if (scalar(@$a) != scalar(@$b)) {
        return 0;
    }
    my %counts = ();
    $counts{$_} += 1 foreach (@$a);
    $counts{$_} -= 1 foreach (@$b);
    return (grep { $_ != 0 } values %counts) ? 0 : 1;
}