package SDB::Install::Configuration::ValueChangeListeners::LSSInstanceUserIDListener;

use strict;
use warnings;
use SDB::Common::BuiltIn;

sub new {
    my ($class) = @_;
    return bless({}, $class);
}

sub onValueChange {
    my ($self, $value, $config) = @_;
    my $userName = SDB::Common::BuiltIn->get_instance()->getpwuid($value);
    if (!$userName) {
        $config->setSkip('LSSPassword', 0);
    } else {
        $config->getMsgLst()->addMessage("Paramater 'LSSPassword' is skipped, because user '$userName' already exists.");
        $config->setSkip('LSSPassword', 1);
    }
    return 1;
}

1;
